%global pypi_name nest_asyncio

Name:           python-nest-asyncio
Version:        1.5.7
Release:    1%{?dist}
Summary:        Patch asyncio to allow nested event loops

License:        BSD
URL:            https://github.com/erdewit/nest_asyncio
Source0:        %{pypi_source}
BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros


%description
By design asyncio does not allow its event loop to be nested.
This presents a practical problem: When in an environment
where the event loop is already running it's impossible to run tasks
and wait for the result. Trying to do so will give the error
"RuntimeError: This event loop is already running".
The issue pops up in various environments, such as web servers,
GUI applications and in Jupyter notebooks.
This module patches asyncio to allow nested use of asyncio.run
and loop.run_until_complete.


%package -n     python3-nest-asyncio
Summary:        %{summary}


%description -n python3-nest-asyncio
By design asyncio does not allow its event loop to be nested.
This presents a practical problem: When in an environment
where the event loop is already running it's impossible to run tasks
and wait for the result. Trying to do so will give the error
"RuntimeError: This event loop is already running".
The issue pops up in various environments, such as web servers,
GUI applications and in Jupyter notebooks.
This module patches asyncio to allow nested use of asyncio.run
and loop.run_until_complete.

%prep
%autosetup -p1 -n %{pypi_name}-%{version}

%generate_buildrequires
%pyproject_buildrequires -r

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files %{pypi_name}

%check
PYTHONPATH=%{buildroot}%{python3_sitelib} %python3 tests/nest_test.py

%files -n python3-nest-asyncio -f %{pyproject_files}
%doc README.rst

%changelog
* Fri Jun 28 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.7-1
- initial build
